Subject: Re: bug#65017: 29.1; Byte compiler interaction with cl-lib function objects, removes symbol-function

From: Stefan Monnier <[email-masked]>
Date: Thu, 03 Aug 2023 17:46:44 -0400

> Sorry about my last post.  I now see what the core problem is, namely
> that (equal 'equal #<symbol equal at 49>) is returning non-nil.

This is not really the core problem IIUC since `cl-macs.el` uses `eq`
rather than `equal` so changing `equal` won't make much of
a difference here.

I'm not sure whether the above should return nil, or non-nil, or the value
of `symbols-with-pos-enabled`, to be honest, but I guess returning non-nil
has worked fine until now, so I think we'd be better off staying with that.

I'd even like it to try and replace uses of `eq/eql` with `equal` in
those cases where we want to overlook differences in symbol-positions, so
that we can eventually get rid of `symbols-with-pos-enabled` which
I consider as a wart.

        Stefan